Prefix: /usr
Summary: The Java runtime library for gcc.
Name: libgcj
Version: 2.96
Release: 29
Copyright: GPL
Group: System Environment/Libraries
URL: http://sourceware.cygnus.com/java/
Source: libgcj-%{version}.tar.bz2
Source2: boehm-gc-3.1-20020314.tar.bz2
Patch1: libgcj-makej.patch
Patch2: libgcj-nomultilib.patch
Patch3: libgcj-compile.patch
Patch4: libgcj-awt-color.patch
Patch5: libgcj-sigaction.patch
Patch6: libgcj-boehmgc.patch
Patch7: libgcj-libdeps.patch
Patch8: libgcj-boehmgc-dyn_load.patch
Patch9: libgcj-nozlib.patch
Patch10: libgcj-new-boehm-gc.patch 
Patch11: libgcj-new-boehm-gc-ltconfig.patch
BuildRequires: gcc-java >= 2.96-95
BuildRequires: zlib-devel
BuildRoot: /var/tmp/libgcj-%{version}-root
Requires: zip >= 2.1
Obsoletes: gcc-libgcj
Prereq: /sbin/install-info
ExcludeArch: ia64

%description
The libgcj package includes the Java runtime library, which is needed
to run Java programs compiled using the gcc Java compiler (gcj).

%package devel
Summary: Libraries for Java development using gcc.
Group: Development/Languages
URL: http://sourceware.cygnus.com/java/
Requires: zip >= 2.1, libgcj = %{version}

%description -n libgcj-devel
The Java static libraries and C header files needed to compile Java
programs using the gcc Java compiler (gcj).

%prep
%setup -q -n libgcj
%patch1 -p1 -b .makej
%patch2 -p1 -b .nomulti
%patch3 -p1 -b .compile
%patch4 -p1 -b .awtcolor
%patch5 -p1 -b .sigaction
%patch6 -p0 -b .boehmgc
%patch7 -p0 -b .libdeps
%patch8 -p0 -b .boehmgc-dyn_load
%patch9 -p1 -b .nozlib
%patch10 -p0 -b .new-boehm-gc
rm -rf zlib
# Replace the old boehm-gc with the one from gcc 3.1
mv boehm-gc boehm-gc-old
tar xfj %{SOURCE2}
%patch11 -p0 -b .new-boehm-gc-ltconfig

%build
rm -fr obj-%{_target_platform}
mkdir obj-%{_target_platform}
cd obj-%{_target_platform}

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%ifarch sparc64
OPT_FLAGS=-O0
%endif
CC="$CC" CFLAGS="$OPT_FLAGS" \
	../configure --prefix %{_prefix} \
	--enable-shared --with-system-zlib --enable-threads=posix --host=%{_target_platform}

make %{?_smp_mflags}

cd ..

for i in boehm-gc/ChangeLog libjava/ChangeLog libffi/ChangeLog; do
	cp -p $i ChangeLog.`echo $i | sed 's|/.*||'`
done
cp -p libffi/LICENSE LICENSE.libffi
cp -p libffi/README README.libffi

%install
rm -fr $RPM_BUILD_ROOT

cd obj-%{_target_platform}
make prefix=$RPM_BUILD_ROOT%{_prefix} install
gcjspecdir=`gcc -v 2>&1 >/dev/null | sed -n 's_^.*%{_prefix}/lib/gcc-lib\(.*\)/specs_%{_prefix}/lib/gcc-lib\1_p'`
mkdir -p $RPM_BUILD_ROOT$gcjspecdir/include
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec $RPM_BUILD_ROOT$gcjspecdir/libgcj.spec
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcj*.a $RPM_BUILD_ROOT$gcjspecdir/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/j*.h $RPM_BUILD_ROOT$gcjspecdir/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,gnu,gcj} $RPM_BUILD_ROOT$gcjspecdir/include/
echo '.text' | gcc -shared -o $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libzgcj.so.0.0.0 \
  -Wl,--soname,libzgcj.so.0 -xassembler - -lz
strip $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libzgcj.so.0.0.0
ln -sf libzgcj.so.0.0.0 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libzgcj.so.0
pushd $RPM_BUILD_ROOT$gcjspecdir
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libgcj.so.1.* libgcj.so
ln -sf ../../../libgcjgc.so.1.* libgcjgc.so
else
ln -sf ../../../../%{_lib}/libgcj.so.1.* libgcj.so
ln -sf ../../../../%{_lib}/libgcjgc.so.1.* libgcjgc.so
fi
popd

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_prefix}/bin/jv-convert
%{_prefix}/bin/gij
%{_prefix}/%{_lib}/lib*gcj*.so.*
%{_prefix}/share/libgcj.zip
%doc ChangeLog* LICENSE.libffi README.libffi

%files devel
%defattr(-,root,root)
%{_prefix}/lib/gcc-lib/*/*/libgcj*.a
%{_prefix}/lib/gcc-lib/*/*/libgcj*.so
%{_prefix}/lib/gcc-lib/*/*/include/j*.h
%{_prefix}/lib/gcc-lib/*/*/include/java
%{_prefix}/lib/gcc-lib/*/*/include/gnu
%{_prefix}/lib/gcc-lib/*/*/include/gcj
%{_prefix}/lib/gcc-lib/*/*/libgcj.spec

%changelog
* Thu Mar 14 2002 Jakub Jelinek <jakub@redhat.com> 2.96-29
- use boehm-gc from gcc 3.1

* Fri Mar 01 2002 Jakub Jelinek <jakub@redhat.com> 2.96-28
- use system zlib

* Mon Aug 27 2001 Jakub Jelinek <jakub@redhat.com> 2.96-27
- Fix boehm-gc so that it does not crash with prelink
  (to use _dl_iterate_phdr API)

* Tue Jul 24 2001 Jakub Jelinek <jakub@redhat.com> 2.96-26
- update to latest boehm-gc
- move so that it can coexist with libgcj3
- fix shared lib dependencies

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.
- Use _smp_mflags macro if applicable

* Wed Feb 14 2001 Jakub Jelinek <jakub@redhat.com>
- Make it compile with glibc 2.2.2.

* Fri Dec 15 2000 Jakub Jelinek <jakub@redhat.com>
- If awt/Color.java, so that it builds with more
  recent gcc.

* Mon Aug 21 2000 Jakub Jelinek <jakub@redhat.com>
- Add ldconfig %%post/%%postun (#16553)

* Mon Aug  7 2000 Jakub Jelinek <jakub@redhat.com>
- distribute libgcj.spec

* Thu Jul 13 2000 Jakub Jelinek <jakub@redhat.com>
- update to 20000713

* Tue Jun  6 2000 Jakub Jelinek <jakub@redhat.com>
- separate from gcc
